## mingw-w64-uv-0.1.33-1.src.tar.zst

=== scripts/scenarios/requirements.txt ===
# This file was autogenerated by uv via the following command:
#    uv pip compile scripts/scenarios/requirements.in -o scripts/scenarios/requirements.txt --refresh-package packse
certifi==2024.2.2
    # via requests
charset-normalizer==3.3.2
    # via requests
chevron-blue==0.2.1
    # via packse
docutils==0.21.post1
    # via readme-renderer
hatchling==1.22.5
    # via packse
idna==3.6
    # via requests
importlib-metadata==7.1.0
    # via twine
jaraco-classes==3.4.0
    # via keyring
jaraco-context==5.3.0
    # via keyring
jaraco-functools==4.0.0
    # via keyring
keyring==25.1.0
    # via twine
markdown-it-py==3.0.0
    # via rich
mdurl==0.1.2
    # via markdown-it-py
more-itertools==10.2.0
    # via
    #   jaraco-classes
    #   jaraco-functools
msgspec==0.18.6
    # via packse
nh3==0.2.17
    # via readme-renderer
packaging==24.0
    # via hatchling
packse==0.3.14
pathspec==0.12.1
    # via hatchling
pkginfo==1.10.0
    # via twine
pluggy==1.4.0
    # via hatchling
pygments==2.17.2
    # via
    #   readme-renderer
    #   rich
readme-renderer==43.0
    # via twine
requests==2.31.0
    # via
    #   requests-toolbelt
    #   twine
requests-toolbelt==1.0.0
    # via twine
rfc3986==2.0.0
    # via twine
rich==13.7.1
    # via twine
setuptools==69.2.0
    # via packse
trove-classifiers==2024.4.10
    # via hatchling
twine==4.0.2
    # via packse
urllib3==2.2.1
    # via
    #   requests
    #   twine
zipp==3.18.1
    # via importlib-metadata

=== PKGBUILD ===
# Maintainer: Maksim Bondarenkov <maksapple2306@gmail.com>

_realname=uv
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}"
         "${MINGW_PACKAGE_PREFIX}-python-${_realname}")
pkgver=0.1.33
pkgrel=1
pkgdesc='An extremely fast Python package installer and resolver, written in Rust (mingw-w64)'
arch=('any')
mingw_arch=('ucrt64' 'clang64' 'clangarm64')
url="https://github.com/astral-sh/uv"
license=('spdx:Apache-2.0 OR MIT')
depends=("${MINGW_PACKAGE_PREFIX}-libgit2"
         "${MINGW_PACKAGE_PREFIX}-libssh2"
         "${MINGW_PACKAGE_PREFIX}-zstd")
makedepends=("${MINGW_PACKAGE_PREFIX}-rust"
             "${MINGW_PACKAGE_PREFIX}-python-maturin"
             "${MINGW_PACKAGE_PREFIX}-python-installer"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-zlib"
             "${MINGW_PACKAGE_PREFIX}-openssl"
             "${MINGW_PACKAGE_PREFIX}-pkgconf")
checkdepends=("${MINGW_PACKAGE_PREFIX}-python"
              "${MINGW_PACKAGE_PREFIX}-python-zstandard"
              #"${MINGW_PACKAGE_PREFIX}-libxcrypt-compat"
              "${MINGW_PACKAGE_PREFIX}-clang")
options=('!strip' '!lto')
source=("https://github.com/astral-sh/uv/archive/${pkgver}/${_realname}-${pkgver}.tar.gz"
        "link-sys-libs-dynamically.patch")
sha256sums=('92d12bf283954c024c7672369985bf5baa5f08d1ddac0d2aa692679aba45b05e'
            'aab389cd81bdb5161733e14947b158df551316977af3f6be36de596e74e581ba')

_env() {
  export LIBGIT2_NO_VENDOR=1
  export OPENSSL_NO_VENDOR=1
  export PKG_CONFIG_ALL_DYNAMIC=1
  export ZSTD_SYS_USE_PKG_CONFIG=1
  export LIBSSH2_SYS_USE_PKG_CONFIG=1
}

prepare() {
  cd "${srcdir}/${_realname}-${pkgver}"

  rm -f rust-toolchain.toml
  mkdir -p .cargo
  cargo vendor --locked --versioned-dirs >> .cargo/config.toml

  patch -Np1 -i "${srcdir}/link-sys-libs-dynamically.patch"
}

build() {
  cd "${srcdir}/${_realname}-${pkgver}"

  _env
  maturin build --frozen --strip --release --all-features
}

check() {
  cd "${srcdir}/${_realname}-${pkgver}"

  _env
  python3 ./scripts/bootstrap/install.py
  cargo test -p uv --frozen --all-features
}

package_uv() {
  cd "${srcdir}/${_realname}-${pkgver}"

  install -Dm755 target/release/uv "${pkgdir}${MINGW_PREFIX}/bin/uv"

  local _complete="./target/release/uv --generate-shell-completion"
  $_complete bash | install -Dm644 /dev/stdin "${pkgdir}${MINGW_PREFIX}/share/bash-completion/completions/uv"
  $_complete fish | install -Dm644 /dev/stdin "${pkgdir}${MINGW_PREFIX}/share/fish/vendor_completions.d/uv.fish"
  $_complete zsh | install -Dm644 /dev/stdin "${pkgdir}${MINGW_PREFIX}/share/zsh/site-functions/_uv"

  install -Dm644 LICENSE-{MIT,APACHE} -t "${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/"
}

package_python-uv() {
  cd "${srcdir}/${_realname}-${pkgver}"

  depends=("${MINGW_PACKAGE_PREFIX}-python" "${MINGW_PACKAGE_PREFIX}-uv")

  MSYS2_ARG_CONV_EXCL="--prefix=" \
    ${MINGW_PREFIX}/bin/python -m installer --prefix=${MINGW_PREFIX} \
    --destdir="${pkgdir}" target/wheels/*.whl

  rm -rf "${pkgdir}${MINGW_PREFIX}/bin"
}

# template start; name=mingw-w64-splitpkg-wrappers; version=1.0;
# vim: set ft=bash :

# generate wrappers
for _name in "${pkgname[@]}"; do
  _short="package_${_name#${MINGW_PACKAGE_PREFIX}-}"
  _func="$(declare -f "${_short}")"
  eval "${_func/#${_short}/package_${_name}}"
done
# template end;
